unit ErrMessages;

                               interface
////////////////////////////////////////////////////////////////////////////////

function GetErrorText(cod: integer): string;

                             implementation
////////////////////////////////////////////////////////////////////////////////
uses
  Errors;

function GetErrorText(cod: integer): string;
begin
  case cod of
    ERR_RESULT_OK:                    result := 'OK!';
    // ERRORS from NXP library
    PH_ERR_IO_TIMEOUT:                result := 'Reader timeout';
    PH_ERR_INTEGRITY_ERROR:           result := 'Reader bad CRC';
    PH_ERR_COLLISION_ERROR:           result := 'Collision error';
    PH_ERR_BUFFER_OVERFLOW:           result := 'Buffer overflow';
    PH_ERR_FRAMING_ERROR:             result := 'Framing error';
    PH_ERR_PROTOCOL_ERROR:            result := 'Protocol error';
    PH_ERR_AUTH_ERROR:                result := 'Authentication error';
    PH_ERR_READ_WRITE_ERROR:          result := 'Read/write error';
    PH_ERR_TEMPERATURE_ERROR:         result := 'Temperature error';
    PH_ERR_RF_ERROR:                  result := 'RF interface error';
    PH_ERR_INTERFACE_ERROR:           result := 'CLRC inerface error';
    PH_ERR_LENGTH_ERROR:              result := 'Length error';
    PH_ERR_INTERNAL_ERROR:            result := 'Internal error';
    //
    PH_ERR_INVALID_DATA_PARAMS:       result := 'Invalid data params';
    PH_ERR_INVALID_PARAMETER:         result := 'Invalid parameter';
    PH_ERR_PARAMETER_OVERFLOW:        result := 'Parameter overflow';
    PH_ERR_UNSUPPORTED_PARAMETER:     result := 'Param not supported';
    PH_ERR_UNSUPPORTED_COMMAND:       result := 'Command not supported';
    PH_ERR_USE_CONDITION:             result := 'Wrong use condition';
    PH_ERR_KEY:                       result := 'Key error';
    //
    PH_ERR_SUCCESS_CHAINING:          result := 'Chaining error';
    PH_ERR_SUCCESS_INCOMPLETE_BYTE:   result := 'Incomplete byte';

    // For Mifare Plus defined codes
    PHAL_MFP_ERR_AUTH:                result := 'MFP Auth Error';
    PHAL_MFP_ERR_CMD_OVERFLOW:        result := 'MFP Command Overflow';
    PHAL_MFP_ERR_MAC_PCD:             result := 'MFP MAC Error';
    PHAL_MFP_ERR_BNR:                 result := 'MFP Block Nr. Error';
    PHAL_MFP_ERR_EXT:                 result := 'MFP Extension Error';
    PHAL_MFP_ERR_CMD_INVALID:         result := 'MFP Invalid Command';
    PHAL_MFP_ERR_FORMAT:              result := 'MFP Format Error';
    PHAL_MFP_ERR_GEN_FAILURE:         result := 'MFP Generic Error';

    // User codes
    ERR_COMM_TIMEOUT:                 result := 'COM timeout';
    ERR_BAD_PACKET_CRC:               result := 'Bad packet CRC';
    ERR_OPEN_PORT:                    result := 'Error open port';
    ERR_WRONG_COMPORT:                result := 'Wrong COM port';
    ERR_COM_CLOSED:                   result := 'COM port closed';
    ERR_COM_WRITEERR:                 result := 'COM write error';
    // error by answers from reader
    ERR_INVALID_DATA:                 result := 'Invalid data in command';
    ERR_INVALID_COMMAND:              result := 'Invalid command';
    ERR_INVALID_PARAM:                result := 'Invalid function param';
  else
    result := 'NO MESSAGE';
  end;
end;

end.
